clear variables;
close all;


% Paramtres **********
Fe = 44100;         % Frquence d'chantillonnage (Hz)
Dursig = 4;         % Dure du signal (s)
FportDeb = 500;     % Frquence porteuse  t = 0
FportFin = 500;     % Frquence porteuse  t = Dursig
FmodDeb = 10;       % Frquence de modulation  t = 0
FmodFin = 10;       % Frquence de modulation  t = Dursig
alphaDeb = 1;       % Indice de modulation  t = 0
alphaFin = 1;       % Indice de modulation  t = Dursig
% *********************

Nech = Dursig*Fe;
t = (1:Nech)' / Fe;

Fport = linspace(FportDeb,FportFin,Nech)';
Fmod  = linspace(FmodDeb,FmodFin,Nech)';
alpha = linspace(alphaDeb,alphaFin,Nech)';

sport = sin(2*pi*Fport.*t);
smod = 1 + alpha.*sin(2*pi*Fmod.*t);
sig = sport.*smod;

Durfen = 2*floor(Fe/20);
fen = hanning(round(Fe/10))';
fens = [fen(1:Durfen/2) ones(1,Nech-Durfen) fen(Durfen/2+1:end)]';
son = sig.*fens;
son = son /(max(son)+0.1);
sound(son,Fe);

Nspec = 2049;
figure;
[S,F,T,P] = spectrogram(sig,hanning(Nspec),round(9/10*Nspec),2^nextpow2(Nspec),Fe);
surf(T,F,10*log10(P),'edgecolor','none'); axis tight; 
view(0,90);
ylim([0,Fe/2]);
xlabel('Time (Seconds)'); ylabel('Hz');
xlabel('Time (Seconds)'); ylabel('Hz');
colorbar;